Index: /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/CreateReplacement.cs
===================================================================
--- /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/CreateReplacement.cs	(revision 1559)
+++ /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/CreateReplacement.cs	(revision 1560)
@@ -45,6 +45,4 @@
     DoubleData probability;
 
-    IList<OperatorBase> operators;
-
     public override string Description {
       get { return @"Implements the control structures of CreateReplacement hard wired. Operators are delegated."; }
@@ -69,10 +67,4 @@
       //AddVariableInfo(new VariableInfo("Random", "Pseudo random number generator", typeof(IRandom), VariableKind.In));
       //AddVariableInfo(new VariableInfo("Elites", "Number of selected sub-scopes", typeof(IntData), VariableKind.In));
-
-      operators = new List<OperatorBase>();
-      operators.Add(ls);
-      operators.Add(rr);
-      operators.Add(rs);
-      operators.Add(lr);
     }
 
Index: unk/sources/HeuristicLab.SGA.Hardwired/3.3/CreateReplacementHardWired.cs
===================================================================
--- /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/CreateReplacementHardWired.cs	(revision 1559)
+++ 	(revision )
@@ -1,87 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Text;
-using System.Linq;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Permutation;
-using HeuristicLab.Evolutionary;
-using HeuristicLab.Operators;
-using HeuristicLab.Routing.TSP;
-
-namespace HeuristicLab.SGA.Hardwired {
-  class CreateReplacementHardWired : OperatorBase {
-    ChildrenInitializer ci;
-    OperatorBase crossover;
-    OperatorBase mutator;
-    OperatorBase evaluator;
-    IRandom random;
-    DoubleData probability;
-
-    public override string Description {
-      get { return @"Implements the functionality CreateReplacement hard wired."; }
-    }
-
-    public CreateReplacementHardWired()
-      : base() {
-      ci = new ChildrenInitializer();
-
-      // variables infos
-      AddVariableInfo(new VariableInfo("Random", "Pseudo random number generator", typeof(IRandom), VariableKind.In));
-      AddVariableInfo(new VariableInfo("MutationRate", "Probability to choose first branch", typeof(DoubleData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("Crossover", "Crossover strategy for SGA", typeof(OperatorBase), VariableKind.In));
-      AddVariableInfo(new VariableInfo("Mutator", "Mutation strategy for SGA", typeof(OperatorBase), VariableKind.In));
-      AddVariableInfo(new VariableInfo("Evaluator", "Evaluation strategy for SGA", typeof(OperatorBase), VariableKind.In));
-      AddVariableInfo(new VariableInfo("SubScopeIndex", "(Optional) the index of the subscope to remove", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("EvaluatedSolutions", "Number of evaluated solutions", typeof(IntData), VariableKind.In | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("Maximization", "Sort in descending order", typeof(BoolData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("Quality", "Sorting value", typeof(DoubleData), VariableKind.In));
-      GetVariableInfo("SubScopeIndex").Local = true;
-    }
-
-    public override IOperation Apply(IScope scope) {
- 
-      // SequentialSubScopesProcessor
-      foreach (IScope s in scope.SubScopes) {
-        //sp2
-        //LeftSelector ls = new LeftSelector();
-        //ls.GetVariableInfo("Selected").ActualName = "Elites";
-        //RightReducer rr = new RightReducer();
-
-        //sp3
-        //RightSelector rs = new RightSelector();
-        //rs.GetVariableInfo("Selected").ActualName = "Elites";
-        //LeftReducer lr = new LeftReducer();
-
-        //MergingReducer mr = new MergingReducer();
-
-        //Sorter s = new Sorter();
-        //s.GetVariableInfo("Descending").ActualName = "Maximization";
-        //s.GetVariableInfo("Value").ActualName = "Quality";
-      } // foreach
-
-      return null;
-    } // Apply
-  } // class CreateReplacementHardWired
-} // namespace HeuristicLab.SGA.Hardwired
Index: /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/HeuristicLab.SGA.Hardwired-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/HeuristicLab.SGA.Hardwired-3.3.csproj	(revision 1559)
+++ /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/HeuristicLab.SGA.Hardwired-3.3.csproj	(revision 1560)
@@ -69,9 +69,9 @@
   <ItemGroup>
     <Compile Include="CreateReplacement.cs" />
-    <Compile Include="CreateReplacementHardWired.cs" />
     <Compile Include="CreateChildrenHardWired.cs" />
     <Compile Include="HeuristicLabSGAHardwiredPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="CreateChildren.cs" />
+    <Compile Include="SGAMainWithHWControllStructures.cs" />
   </ItemGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/SGAMainWithHWControllStructures.cs
===================================================================
--- /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/SGAMainWithHWControllStructures.cs	(revision 1560)
+++ /trunk/sources/HeuristicLab.SGA.Hardwired/3.3/SGAMainWithHWControllStructures.cs	(revision 1560)
@@ -0,0 +1,86 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Linq;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Permutation;
+using HeuristicLab.Evolutionary;
+using HeuristicLab.Operators;
+using HeuristicLab.Routing.TSP;
+using HeuristicLab.Logging;
+
+namespace HeuristicLab.SGA.Hardwired {
+  class SGAMainWithHWControllStructures : CombinedOperator {
+    public override string Description {
+      get { return @"Implements the SGAMain with hardwired control structures. Operators are delegated."; }
+    }
+
+    public SGAMainWithHWControllStructures()
+      : base() {
+      AddVariableInfo(new VariableInfo("Selector", "Selection strategy for SGA", typeof(OperatorBase), VariableKind.In));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      int nrOfGenerations = 1000;
+
+      OperatorBase selector = (OperatorBase)GetVariableValue("Selector", scope, true);
+      OperatorBase createChildren = new CreateChildren();
+      OperatorBase createReplacement = new CreateReplacement();
+      QualityLogger ql = new QualityLogger();
+      
+      BestAverageWorstQualityCalculator bawqc = new BestAverageWorstQualityCalculator();
+      DataCollector dc = new DataCollector();
+      ItemList<StringData> names = dc.GetVariable("VariableNames").GetValue<ItemList<StringData>>();
+      names.Add(new StringData("BestQuality"));
+      names.Add(new StringData("AverageQuality"));
+      names.Add(new StringData("WorstQuality"));
+      
+      LinechartInjector lci = new LinechartInjector();
+      lci.GetVariableInfo("Linechart").ActualName = "Quality Linechart";
+      lci.GetVariable("NumberOfLines").GetValue<IntData>().Data = 3;
+
+      Counter c = new Counter();
+      c.GetVariableInfo("Value").ActualName = "Generations";
+
+      LessThanComparator ltc = new LessThanComparator();
+      ltc.GetVariableInfo("LeftSide").ActualName = "Generations";
+      ltc.GetVariableInfo("RightSide").ActualName = "MaximumGenerations";
+      ltc.GetVariableInfo("Result").ActualName = "GenerationsCondition";
+
+      for (int i = 0; i < nrOfGenerations; i++) {
+        selector.Execute(scope);
+        createChildren.Execute(scope.SubScopes[1]);
+        createReplacement.Execute(scope);
+        ql.Execute(scope);
+        bawqc.Equals(scope);
+        dc.Execute(scope);
+        lci.Execute(scope);
+        c.Execute(scope);
+        ltc.Execute(scope);
+      }
+      return null;
+    } // Apply
+  } // class SGAMainWithHWControllStructures
+} // namespace HeuristicLab.SGA.Hardwired