Index: trunk/sources/HeuristicLab.Visualization/3.2/DataRow.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/DataRow.cs	(revision 1559)
+++ trunk/sources/HeuristicLab.Visualization/3.2/DataRow.cs	(revision 1561)
@@ -30,8 +30,18 @@
 
     public DataRow(string label, Color color, int thickness, DrawingStyle style, List<double> dataRow) {
-     this.Label = label;
+      this.Label = label;
       this.Color = color;
       this.Thickness = thickness;
       this.Style = style;
+      this.dataRow = dataRow;
+      this.ShowMarkers = true;
+    }
+
+    public DataRow(string label, Color color, int thickness, DrawingStyle style, List<double> dataRow, bool showMarkers) {
+      this.Label = label;
+      this.Color = color;
+      this.Thickness = thickness;
+      this.Style = style;
+      this.ShowMarkers = showMarkers;
       this.dataRow = dataRow;
     }
Index: trunk/sources/HeuristicLab.Visualization/3.2/DataRowBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/DataRowBase.cs	(revision 1559)
+++ trunk/sources/HeuristicLab.Visualization/3.2/DataRowBase.cs	(revision 1561)
@@ -9,4 +9,13 @@
     private DataRowType lineType = DataRowType.Normal;
     private YAxisDescriptor yAxis;
+    private bool showMarkers = true;
+
+    public bool ShowMarkers {
+      get { return showMarkers; }
+      set {
+        showMarkers = value;
+        OnDataRowChanged(this);
+      }
+    }          
 
     public string Label {
Index: trunk/sources/HeuristicLab.Visualization/3.2/IDataRow.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/IDataRow.cs	(revision 1559)
+++ trunk/sources/HeuristicLab.Visualization/3.2/IDataRow.cs	(revision 1561)
@@ -12,4 +12,5 @@
     DrawingStyle Style { get; set; }
     DataRowType LineType { get; set; }
+    bool ShowMarkers { get; set; }
  
     YAxisDescriptor YAxis { get; set; }
Index: trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs	(revision 1559)
+++ trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs	(revision 1561)
@@ -389,4 +389,5 @@
         }
       } else {
+        rowEntry.showMarkers(row.ShowMarkers);
         for (int i = 1; i < row.Count; i++) {
           LineShape lineShape = new LineShape(i - 1, row[i - 1], i, row[i], row.Color, row.Thickness, row.Style);
@@ -602,4 +603,5 @@
           }
         }
+        this.markersShape.ShowChildShapes = row.ShowMarkers;
       }
 
@@ -648,10 +650,6 @@
       }
 
-      public void hideMarkers() {
-        linesShape.markersShape.ShowChildShapes = false;
-      }
-
-      public void showMarkers() {
-        linesShape.markersShape.ShowChildShapes = true;
+      public void showMarkers(bool flag) {
+        linesShape.markersShape.ShowChildShapes = flag;
       }
     }
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs	(revision 1559)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs	(revision 1561)
@@ -48,8 +48,9 @@
       this.btnChangeXAxisFont = new System.Windows.Forms.Button();
       this.tpYAxes = new System.Windows.Forms.TabPage();
+      this.gbxYAxisClipChangeable = new System.Windows.Forms.GroupBox();
+      this.flpYAxisClipChangeable = new System.Windows.Forms.FlowLayoutPanel();
       this.gbxShowYAxis = new System.Windows.Forms.GroupBox();
-      this.gbxYAxisClipChangeable = new System.Windows.Forms.GroupBox();
       this.flpShowYAxis = new System.Windows.Forms.FlowLayoutPanel();
-      this.flpYAxisClipChangeable = new System.Windows.Forms.FlowLayoutPanel();
+      this.MarkercheckBox = new System.Windows.Forms.CheckBox();
       this.tpTitle.SuspendLayout();
       this.tabPage2.SuspendLayout();
@@ -59,6 +60,6 @@
       this.tpXAxis.SuspendLayout();
       this.tpYAxes.SuspendLayout();
+      this.gbxYAxisClipChangeable.SuspendLayout();
       this.gbxShowYAxis.SuspendLayout();
-      this.gbxYAxisClipChangeable.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -224,4 +225,5 @@
       // groupBox1
       // 
+      this.groupBox1.Controls.Add(this.MarkercheckBox);
       this.groupBox1.Controls.Add(this.label4);
       this.groupBox1.Controls.Add(this.LineThicknessCB);
@@ -307,4 +309,25 @@
       this.tpYAxes.UseVisualStyleBackColor = true;
       // 
+      // gbxYAxisClipChangeable
+      // 
+      this.gbxYAxisClipChangeable.AutoSize = true;
+      this.gbxYAxisClipChangeable.Controls.Add(this.flpYAxisClipChangeable);
+      this.gbxYAxisClipChangeable.Location = new System.Drawing.Point(0, 82);
+      this.gbxYAxisClipChangeable.Name = "gbxYAxisClipChangeable";
+      this.gbxYAxisClipChangeable.Size = new System.Drawing.Size(281, 76);
+      this.gbxYAxisClipChangeable.TabIndex = 1;
+      this.gbxYAxisClipChangeable.TabStop = false;
+      this.gbxYAxisClipChangeable.Text = "Y-Axis-Clip changeable";
+      // 
+      // flpYAxisClipChangeable
+      // 
+      this.flpYAxisClipChangeable.AutoSize = true;
+      this.flpYAxisClipChangeable.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.flpYAxisClipChangeable.FlowDirection = System.Windows.Forms.FlowDirection.TopDown;
+      this.flpYAxisClipChangeable.Location = new System.Drawing.Point(3, 16);
+      this.flpYAxisClipChangeable.Name = "flpYAxisClipChangeable";
+      this.flpYAxisClipChangeable.Size = new System.Drawing.Size(275, 57);
+      this.flpYAxisClipChangeable.TabIndex = 0;
+      // 
       // gbxShowYAxis
       // 
@@ -318,15 +341,4 @@
       this.gbxShowYAxis.Text = "Show Y-Axis";
       // 
-      // gbxYAxisClipChangeable
-      // 
-      this.gbxYAxisClipChangeable.AutoSize = true;
-      this.gbxYAxisClipChangeable.Controls.Add(this.flpYAxisClipChangeable);
-      this.gbxYAxisClipChangeable.Location = new System.Drawing.Point(0, 82);
-      this.gbxYAxisClipChangeable.Name = "gbxYAxisClipChangeable";
-      this.gbxYAxisClipChangeable.Size = new System.Drawing.Size(281, 76);
-      this.gbxYAxisClipChangeable.TabIndex = 1;
-      this.gbxYAxisClipChangeable.TabStop = false;
-      this.gbxYAxisClipChangeable.Text = "Y-Axis-Clip changeable";
-      // 
       // flpShowYAxis
       // 
@@ -339,13 +351,14 @@
       this.flpShowYAxis.TabIndex = 0;
       // 
-      // flpYAxisClipChangeable
-      // 
-      this.flpYAxisClipChangeable.AutoSize = true;
-      this.flpYAxisClipChangeable.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.flpYAxisClipChangeable.FlowDirection = System.Windows.Forms.FlowDirection.TopDown;
-      this.flpYAxisClipChangeable.Location = new System.Drawing.Point(3, 16);
-      this.flpYAxisClipChangeable.Name = "flpYAxisClipChangeable";
-      this.flpYAxisClipChangeable.Size = new System.Drawing.Size(275, 57);
-      this.flpYAxisClipChangeable.TabIndex = 0;
+      // MarkercheckBox
+      // 
+      this.MarkercheckBox.AutoSize = true;
+      this.MarkercheckBox.Location = new System.Drawing.Point(142, 106);
+      this.MarkercheckBox.Name = "MarkercheckBox";
+      this.MarkercheckBox.Size = new System.Drawing.Size(59, 17);
+      this.MarkercheckBox.TabIndex = 9;
+      this.MarkercheckBox.Text = "Marker";
+      this.MarkercheckBox.UseVisualStyleBackColor = true;
+      this.MarkercheckBox.CheckedChanged += new System.EventHandler(this.MarkercheckBox_CheckedChanged);
       // 
       // OptionsDialog
@@ -373,8 +386,8 @@
       this.tpYAxes.ResumeLayout(false);
       this.tpYAxes.PerformLayout();
+      this.gbxYAxisClipChangeable.ResumeLayout(false);
+      this.gbxYAxisClipChangeable.PerformLayout();
       this.gbxShowYAxis.ResumeLayout(false);
       this.gbxShowYAxis.PerformLayout();
-      this.gbxYAxisClipChangeable.ResumeLayout(false);
-      this.gbxYAxisClipChangeable.PerformLayout();
       this.ResumeLayout(false);
 
@@ -411,4 +424,5 @@
     private System.Windows.Forms.FlowLayoutPanel flpYAxisClipChangeable;
     private System.Windows.Forms.FlowLayoutPanel flpShowYAxis;
+    private System.Windows.Forms.CheckBox MarkercheckBox;
   }
 }
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.cs	(revision 1559)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.cs	(revision 1561)
@@ -17,4 +17,5 @@
       string Label { get; set; }
       Color Color { get; set; }
+      bool ShowMarkers { get; set; }
       int Thickness { get; set; }
       DrawingStyle Style { get; set; }
@@ -27,4 +28,5 @@
         Style = row.Style;
         this.row = row;
+        this.ShowMarkers = row.ShowMarkers; 
       }
 
@@ -34,4 +36,5 @@
         row.Thickness = Thickness;
         row.Style = Style;
+        row.ShowMarkers = this.ShowMarkers;
       }
     }
@@ -83,4 +86,5 @@
         LinestyleCB.SelectedItem = model.Rows[0].Style;
         LineThicknessCB.SelectedItem = model.Rows[0].Thickness;
+        MarkercheckBox.Checked = model.Rows[0].ShowMarkers;
 
         LineSelectCB.DataSource = model.Rows;
@@ -128,5 +132,6 @@
         LineThicknessCB.SelectedItem = ((IDataRow) LineSelectCB.SelectedValue).Thickness;
         LinestyleCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).Style;
-        ColorPreviewTB.BackColor = ((IDataRow)LineSelectCB.SelectedValue).Color;   
+        ColorPreviewTB.BackColor = ((IDataRow)LineSelectCB.SelectedValue).Color;
+        MarkercheckBox.Checked = ((IDataRow) LineSelectCB.SelectedValue).ShowMarkers;
       }
     }
@@ -218,4 +223,11 @@
         ((IDataRow)LineSelectCB.SelectedValue).Thickness = (int)LineThicknessCB.SelectedItem;
     }
+
+    private void MarkercheckBox_CheckedChanged(object sender, EventArgs e) {
+      if (LineSelectCB.SelectedValue != null)
+        ((IDataRow) LineSelectCB.SelectedValue).ShowMarkers = MarkercheckBox.Checked;
+    }
+
+
   }
 }