Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/DoubleArray2XmlFormatters.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/DoubleArray2XmlFormatters.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/DoubleArray2XmlFormatters.cs	(revision 1566)
@@ -4,7 +4,7 @@
 
 namespace HeuristicLab.Persistence.Default.Xml.Compact {
-  
+
   public abstract class DoubleArray2XmlFormatterBase<T> : NumberArray2XmlFormatterBase<T> {
-    
+
     protected override string FormatValue(object o) {
       return ((double)o).ToString("r", CultureInfo.InvariantCulture);
@@ -24,5 +24,5 @@
 
   [EmptyStorableClass]
-  public class Double3DArray2XmlFormatter : DoubleArray2XmlFormatterBase<double[,,]> { }
-  
+  public class Double3DArray2XmlFormatter : DoubleArray2XmlFormatterBase<double[, ,]> { }
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/DoubleList2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/DoubleList2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/DoubleList2XmlFormatter.cs	(revision 1566)
@@ -8,5 +8,5 @@
 
   [EmptyStorableClass]
-  public class DoubleList2XmlFormatter : NumberEnumeration2XmlFormatterBase<List<double>> {    
+  public class DoubleList2XmlFormatter : NumberEnumeration2XmlFormatterBase<List<double>> {
 
     protected override void Add(IEnumerable enumeration, object o) {
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/IntArray2XmlFormatters.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/IntArray2XmlFormatters.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/IntArray2XmlFormatters.cs	(revision 1566)
@@ -3,6 +3,6 @@
 
 namespace HeuristicLab.Persistence.Default.Xml.Compact {
-  
-  public abstract class IntArray2XmlFormatterBase<T> : NumberArray2XmlFormatterBase<T> {    
+
+  public abstract class IntArray2XmlFormatterBase<T> : NumberArray2XmlFormatterBase<T> {
 
     protected override string FormatValue(object o) {
@@ -22,5 +22,5 @@
 
   [EmptyStorableClass]
-  public class Int3DArray2XmlFormatter : IntArray2XmlFormatterBase<int[,,]> { }
-  
+  public class Int3DArray2XmlFormatter : IntArray2XmlFormatterBase<int[, ,]> { }
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/IntList2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/IntList2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/IntList2XmlFormatter.cs	(revision 1566)
@@ -8,5 +8,5 @@
   [EmptyStorableClass]
   public class IntList2XmlFormatter : NumberEnumeration2XmlFormatterBase<List<int>> {
-    
+
     protected override void Add(IEnumerable enumeration, object o) {
       ((List<int>)enumeration).Add((int)o);
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/NumberArray2XmlFormatterBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/NumberArray2XmlFormatterBase.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/NumberArray2XmlFormatterBase.cs	(revision 1566)
@@ -5,5 +5,5 @@
 
 namespace HeuristicLab.Persistence.Default.Xml.Compact {
-                                                              
+
   public abstract class NumberArray2XmlFormatterBase<T> : FormatterBase<T, XmlString> {
 
@@ -30,5 +30,5 @@
       }
       int[] positions = (int[])lowerBounds.Clone();
-      while (positions[a.Rank - 1] < lengths[a.Rank - 1] + lowerBounds[a.Rank - 1]) {        
+      while (positions[a.Rank - 1] < lengths[a.Rank - 1] + lowerBounds[a.Rank - 1]) {
         sb.Append(Separator);
         sb.Append(FormatValue(a.GetValue(positions)));
@@ -42,5 +42,5 @@
           }
         }
-      }      
+      }
       return new XmlString(sb.ToString());
     }
@@ -80,4 +80,4 @@
     }
   }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/NumberEnumeration2XmlFormatterBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/NumberEnumeration2XmlFormatterBase.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Compact/NumberEnumeration2XmlFormatterBase.cs	(revision 1566)
@@ -5,5 +5,5 @@
 
 namespace HeuristicLab.Persistence.Default.Xml.Compact {
-  
+
   public abstract class NumberEnumeration2XmlFormatterBase<T> : FormatterBase<T, XmlString> where T : IEnumerable {
 
@@ -32,4 +32,4 @@
     }
   }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Bool2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Bool2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Bool2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class Bool2XmlFormatter : SimpleNumber2XmlFormatterBase<bool> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Byte2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Byte2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Byte2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class Byte2XmlFormatter : SimpleNumber2XmlFormatterBase<byte> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/DateTime2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/DateTime2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/DateTime2XmlFormatter.cs	(revision 1566)
@@ -6,8 +6,8 @@
 
   [EmptyStorableClass]
-  public class DateTime2XmlFormatter : FormatterBase<DateTime, XmlString> {    
-    
+  public class DateTime2XmlFormatter : FormatterBase<DateTime, XmlString> {
+
     public override XmlString Format(DateTime dt) {
-      return new XmlString(dt.Ticks.ToString());      
+      return new XmlString(dt.Ticks.ToString());
     }
 
@@ -18,4 +18,4 @@
   }
 
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Decimal2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Decimal2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Decimal2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class Decimal2XmlFormatter : DecimalNumber2XmlFormatterBase<decimal> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/DecimalNumber2XmlFormatterBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/DecimalNumber2XmlFormatterBase.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/DecimalNumber2XmlFormatterBase.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   public abstract class DecimalNumber2XmlFormatterBase<T> : FormatterBase<T, XmlString> {
-    
+
     private static MethodInfo ToStringMethod = typeof(T)
       .GetMethod(
@@ -30,7 +30,7 @@
       return new XmlString((string)ToStringMethod.Invoke(t, new object[] { "r", CultureInfo.InvariantCulture }));
     }
-    public override T Parse(XmlString x) {      
+    public override T Parse(XmlString x) {
       return (T)ParseMethod.Invoke(null, new object[] { x.Data, CultureInfo.InvariantCulture });
     }
-  }  
+  }
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Double2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Double2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Double2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-    
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class Double2XmlFormatter : DecimalNumber2XmlFormatterBase<double> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Float2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Float2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Float2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-   
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class Float2XmlFormatter : DecimalNumber2XmlFormatterBase<float> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Int2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Int2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Int2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
 
   [EmptyStorableClass]
   public class Int2XmlFormatter : SimpleNumber2XmlFormatterBase<int> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Long2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Long2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Long2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
 
   [EmptyStorableClass]
   public class Long2XmlFormatter : SimpleNumber2XmlFormatterBase<long> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/SByte2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/SByte2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/SByte2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class Sbyte2XmlFormatter : SimpleNumber2XmlFormatterBase<sbyte> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Short2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Short2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/Short2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class Short2XmlFormatter : SimpleNumber2XmlFormatterBase<short> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/SimpleNumber2XmlFormatterBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/SimpleNumber2XmlFormatterBase.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/SimpleNumber2XmlFormatterBase.cs	(revision 1566)
@@ -5,5 +5,5 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
 
   public abstract class SimpleNumber2XmlFormatterBase<T> : FormatterBase<T, XmlString> {
@@ -22,6 +22,6 @@
     }
     public override T Parse(XmlString x) {
-      return (T)ParseMethod.Invoke(null, new[] { x.Data });      
+      return (T)ParseMethod.Invoke(null, new[] { x.Data });
     }
-  }  
+  }
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/String2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/String2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/String2XmlFormatter.cs	(revision 1566)
@@ -9,5 +9,5 @@
   [EmptyStorableClass]
   public class String2XmlFormatter : FormatterBase<string, XmlString> {
-    
+
     public override XmlString Format(string s) {
       StringBuilder sb = new StringBuilder();
@@ -15,5 +15,5 @@
       sb.Append(s.Replace("]]>", "]]]]><![CDATA[>"));
       sb.Append("]]>");
-      return new XmlString(sb.ToString());  
+      return new XmlString(sb.ToString());
     }
 
@@ -22,5 +22,5 @@
     public override string Parse(XmlString x) {
       StringBuilder sb = new StringBuilder();
-      foreach (string s in x.Data.Split(separators,        
+      foreach (string s in x.Data.Split(separators,
         StringSplitOptions.RemoveEmptyEntries)) {
         sb.Append(s);
@@ -28,4 +28,4 @@
       return sb.ToString();
     }
-  }  
+  }
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/UInt2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/UInt2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/UInt2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class UInt2XmlFormatter : SimpleNumber2XmlFormatterBase<uint> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/ULong2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/ULong2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/ULong2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
-  public class ULong2XmlFormatter : SimpleNumber2XmlFormatterBase<ulong> { }  
-  
+  public class ULong2XmlFormatter : SimpleNumber2XmlFormatterBase<ulong> { }
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/UShort2XmlFormatter.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/UShort2XmlFormatter.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/Primitive/UShort2XmlFormatter.cs	(revision 1566)
@@ -5,8 +5,8 @@
 using System.Globalization;
 
-namespace HeuristicLab.Persistence.Default.Xml.Primitive {  
-  
+namespace HeuristicLab.Persistence.Default.Xml.Primitive {
+
   [EmptyStorableClass]
   public class UShort2XmlFormatter : SimpleNumber2XmlFormatterBase<ushort> { }
-  
+
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlFormat.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlFormat.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlFormat.cs	(revision 1566)
@@ -6,5 +6,5 @@
   [EmptyStorableClass]
   public class XmlFormat : FormatBase<XmlString> {
-    public override string Name { get { return "XML"; } }    
+    public override string Name { get { return "XML"; } }
   }
 
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlGenerator.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlGenerator.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlGenerator.cs	(revision 1566)
@@ -21,7 +21,7 @@
     public const string METAINFO = "METAINFO";
   }
-  
+
   public class XmlGenerator : GeneratorBase<string> {
-    
+
     private int depth;
 
@@ -45,5 +45,5 @@
       if (type == NodeType.End)
         sb.Append('/');
-      sb.Append(name);      
+      sb.Append(name);
       foreach (var attribute in attributes) {
         if (attribute.Value != null && !string.IsNullOrEmpty(attribute.Value.ToString())) {
@@ -58,5 +58,5 @@
         sb.Append('/');
       sb.Append(">");
-      return sb.ToString();      
+      return sb.ToString();
     }
 
@@ -65,5 +65,5 @@
     }
 
-    protected override string Format(BeginToken beginToken) {            
+    protected override string Format(BeginToken beginToken) {
       var attributes = new Dictionary<string, object> {
         {"name", beginToken.Name},
@@ -76,10 +76,10 @@
     }
 
-    protected override string Format(EndToken endToken) {      
+    protected override string Format(EndToken endToken) {
       depth -= 1;
       return Prefix + "</" + XmlStrings.COMPOSITE + ">\r\n";
     }
 
-    protected override string Format(PrimitiveToken dataToken) {      
+    protected override string Format(PrimitiveToken dataToken) {
       var attributes =
         new Dictionary<string, object> {
@@ -89,17 +89,17 @@
       return Prefix +
         FormatNode(XmlStrings.PRIMITIVE, attributes, NodeType.Start) +
-        ((XmlString)dataToken.SerialData).Data + "</" + XmlStrings.PRIMITIVE + ">\r\n";      
+        ((XmlString)dataToken.SerialData).Data + "</" + XmlStrings.PRIMITIVE + ">\r\n";
     }
 
-    protected override string Format(ReferenceToken refToken) {      
+    protected override string Format(ReferenceToken refToken) {
       var attributes = new Dictionary<string, object> {
         {"ref", refToken.Id},
-        {"name", refToken.Name}};                                       
-      return Prefix + FormatNode(XmlStrings.REFERENCE, attributes, NodeType.Inline) + "\r\n";  
+        {"name", refToken.Name}};
+      return Prefix + FormatNode(XmlStrings.REFERENCE, attributes, NodeType.Inline) + "\r\n";
     }
 
-    protected override string Format(NullReferenceToken nullRefToken) {      
+    protected override string Format(NullReferenceToken nullRefToken) {
       var attributes = new Dictionary<string, object>{
-        {"name", nullRefToken.Name}};      
+        {"name", nullRefToken.Name}};
       return Prefix + FormatNode(XmlStrings.NULL, attributes, NodeType.Inline) + "\r\n";
     }
@@ -127,5 +127,5 @@
     }
 
-    public static void Serialize(object o, string filename) {      
+    public static void Serialize(object o, string filename) {
       Serialize(o, filename, ConfigurationService.Instance.GetDefaultConfig(new XmlFormat()));
     }
@@ -135,8 +135,8 @@
       XmlGenerator generator = new XmlGenerator();
       ZipOutputStream zipStream = new ZipOutputStream(File.Create(filename));
-      zipStream.SetLevel(9);      
-      zipStream.PutNextEntry(new ZipEntry("data.xml"));      
+      zipStream.SetLevel(9);
+      zipStream.PutNextEntry(new ZipEntry("data.xml"));
       StreamWriter writer = new StreamWriter(zipStream);
-      ILog logger = Logger.GetDefaultLogger();      
+      ILog logger = Logger.GetDefaultLogger();
       foreach (ISerializationToken token in serializer) {
         string line = generator.Format(token);
@@ -151,6 +151,6 @@
         logger.Debug(line);
       }
-      writer.Flush();            
-      zipStream.Close();      
+      writer.Flush();
+      zipStream.Close();
     }
 
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlParser.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlParser.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlParser.cs	(revision 1566)
@@ -19,8 +19,8 @@
     public XmlParser(TextReader input) {
       XmlReaderSettings settings = new XmlReaderSettings {
-                                       ConformanceLevel = ConformanceLevel.Document,
-                                       IgnoreWhitespace = true,
-                                       IgnoreComments = true
-                                     };
+        ConformanceLevel = ConformanceLevel.Document,
+        IgnoreWhitespace = true,
+        IgnoreComments = true
+      };
       reader = XmlReader.Create(input, settings);
       handlers = new Dictionary<string, Handler> {
@@ -66,5 +66,5 @@
 
     private IEnumerator<ISerializationToken> ParseComposite() {
-      string name = reader.GetAttribute("name");            
+      string name = reader.GetAttribute("name");
       string idString = reader.GetAttribute("id");
       int? id = null;
@@ -104,5 +104,5 @@
       var typeCache = new List<TypeMapping>();
       XmlReader xmlReader = XmlReader.Create(reader);
-      while ( xmlReader.Read() ) {
+      while (xmlReader.Read()) {
         if (xmlReader.Name == XmlStrings.TYPE) {
           typeCache.Add(new TypeMapping(
@@ -116,5 +116,5 @@
 
     public static object DeSerialize(string filename) {
-      ZipFile zipFile = new ZipFile(filename);      
+      ZipFile zipFile = new ZipFile(filename);
       Deserializer deSerializer = new Deserializer(
         ParseTypeCache(
@@ -123,6 +123,6 @@
       XmlParser parser = new XmlParser(
         new StreamReader(zipFile.GetInputStream(zipFile.GetEntry("data.xml"))));
-      return deSerializer.Deserialize(parser);      
+      return deSerializer.Deserialize(parser);
     }
-  }  
+  }
 }
Index: trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlString.cs
===================================================================
--- trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlString.cs	(revision 1564)
+++ trunk/sources/HeuristicLab.Persistence/3.3/Default/Xml/XmlString.cs	(revision 1566)
@@ -3,5 +3,5 @@
 
 namespace HeuristicLab.Persistence.Default.Xml {
-  
+
   public class XmlString : ISerialData {
 